// Programming techniques
//
// User-defined library: Common Functions
// --------------------------------------

#include <cmath>
using namespace std;

double const pi=4.0*atan(1.0);

double grad2rad(double g)
{
     return g*pi/200.;
}

double rad2grad(double r)
{
     return r*200./pi;
}

double rad2ddeg(double r)
{
     return r*180./pi;
}

void rad2sdeg(double r,int &deg, int &mn, double &sc)
{
     double dd, mm;
     int p=1;
     if (r<0.) p=-1;     
     dd=fabs(r)*180./pi;
     deg=floor(dd);
     mm=(dd-deg)*60.;
     if (60.==mm) {
        mm=mm-60.;
        deg=deg+1; }
     mn=floor(mm);
     sc=(mm-mn)*60.;
     if (60.==sc) {
        sc=sc-60.;
        mn=mn+1; }     
     deg=deg*p;
}

void ortho2polar(double x, double y, double &r, double &a)
{
     double q=0.;
     r=sqrt(x*x+y*y);
     if (x<0.) 
        q=pi;
     if (y==0.) 
        a=q+0.5*pi;
     else {
        a=atan(x/y);
        if (y<0.) 
           a=a+pi;  
        else
           a=a+2.*q;
       }
}

void polar2ortho(double r, double ag, double &x, double &y)
{
     double a;
     a=grad2rad(ag);
     x=r*sin(a);
     y=r*cos(a);
}

double line_length(double x1, double y1, double x2, double y2)
{
    double s;
    s=sqrt((x1-x2)*(x1-x2)+(y1-y2)*(y1-y2));
    return s;
}

double triangle_area(double a, double b, double c)
{
       double s, ar;
       s=0.5*(a+b+c);
       ar=sqrt(s*(s-a)*(s-b)*(s-c));
       return ar;
}

void rotate_vector2D(double &x, double &y, double r)
{
     double t=x;
     x=t*cos(r)-y*sin(r);
     y=t*sin(r)+y*cos(r);
}
